{$N+}
program lagrange_demo;  {ehd april 1991/februari 1994/ mw februari 1995}
                        {aangepast voor Nemo januari 2008}
uses Dos,Crt,GritN,cmstuf;
const MAXP=20;
      MAXL=100;
type punt = record x,y: real end;           {point}
     stuurpunten = array[0..MAXP+1] of punt;    {interpolation points}
     datarr = array[1..MAXL+1] of real;
var p: stuurpunten;
    i,neval,number: integer;
    x,y: datarr;
    done: boolean;
    teksten: ButtTxtArr;
    kleur: integer;

procedure lagrange(p: stuurpunten; n: integer; var x,y: datarr);
var i,j,k: integer;
    teller,noemer: real;
    ti: array[0..MAXP+1] of real;
    t,lin_t: real;
    ade: byte;
begin
  for i:=0 to n do ti[i]:=i/n;
    for k:=1 to MAXL do
      begin
          x[k]:=0;
          y[k]:=0;
          t:=(k-1)/(MAXL-1);
             for i:=0 to n do
                begin
                   teller:=1;
                   noemer:=1;
                   for j:=0 to n do
                     begin
                        if j<>i then teller:=teller*(t-ti[j]);
                        if j<>i then noemer:=noemer*(ti[i]-ti[j]);
                     end;
                   lin_t:=teller/noemer;
                   x[k]:=x[k]+p[i].x*lin_t;
                   y[k]:=y[k]+p[i].y*lin_t
                end
      end
end;

procedure StuurpDef(var s: stuurpunten; var number: integer);
var knop: integer;
    i: integer;
    u,v: real;
begin
     Prompt('Click 2 to 20 interpolation points; right-click AFTER the last point');
     i:=0;
     repeat
       Locator(u,v,knop);
       if (knop=1) or (i<2) then
         begin
           Marker(u,v,plus,kleur);
           s[i].x:=u;
           s[i].y:=v;
           if i>0 then
             Drawline(s[i-1].x,s[i-1].y,s[i].x,s[i].y,kleur);
           knop:=1;
           i:=i+1
         end;
     until (knop=2) or (i=MAXP);
     number:=i-1; {real # interp pnts is number+1 as count starts with 0}
     ClearViewport
end;


procedure edit(var done: boolean);
var q,ok: integer;

procedure grab(var u,v: real; var n: integer);
var mindist,d: real;
    i: integer;

function dist(x,y: real; n: integer; var d: real): real;
begin
     d:=sqr(x-p[n].x)+sqr(y-p[n].y);
     dist:=d
end;

begin
     mindist:=1000;
     for i:=number downto 0 do
         if dist(u,v,i,d) < mindist then begin n:=i; mindist:=d end;
     u:=p[n].x; v:=p[n].y
end;  {grab}

procedure append;
var i,m,n: integer;
    knop: integer;
    ade: byte;
    u,v: real;
begin
     if number>=MAXP-1 then
       begin
         Prompt('Maximum 20 points! -- press  <space>');
         Wait(-1,ade);
         exit
       end;
     Prompt('Click the predecessor of the point to be inserted');
     Locator(u,v,knop); grab(u,v,n);
     setmarkermode(exclor);
     Marker(p[n].x,p[n].y,fsquare,white);
     if n<number then
       Marker(p[n+1].x,p[n+1].y,fsquare,white);
     Prompt('Click the interpolation point to be inserted');
     Locator(u,v,knop);
     Marker(p[n].x,p[n].y,fsquare,white);
     if n<number then
       Marker(p[n+1].x,p[n+1].y,fsquare,white);
     setmarkermode(overwrite);
     m:=n+1;
     for i:=number downto m do p[i+1]:=p[i];
     p[m].x:=u; p[m].y:=v;
     number:=number+1;
end;

procedure move;
var n: integer;
    knop: integer;
    u,v: real;
begin
     Prompt('Click the interpolation point to be moved');
     Locator(u,v,knop); grab(u,v,n);
     setmarkermode(exclor);
     Marker(p[n].x,p[n].y,fsquare,white);
     Prompt('Click new position of the marked point:');
     Locator(u,v,knop);
     Marker(p[n].x,p[n].y,fsquare,white);
     setmarkermode(overwrite);
     p[n].x:=u; p[n].y:=v;
end;

procedure delete;
var i,n,knop: integer;
    ade:byte;
    u,v: real;
begin
     if number<2 then
       begin
         Prompt('At least 2 points!! -- press the <space> bar');
         Wait(-1,ade);
         exit
       end;
     Prompt('Click the interpolation point to be deleted');
     Locator(u,v,knop); grab(u,v,n);
     for i:=n to number do p[i]:=p[i+1];
     number:=number-1
end;

procedure display;
var i,j,k: integer;
begin
    { ClearViewport; }
     k:=(kleur+11) mod 13 +1;
     for i:=1 to 13 do
      begin
       j:=(i+12-kleur)mod 13+1;
       j:=j*15;
       if i=kleur
        then SetPaletEntry(1,i,255,0,255)
        else if i=k
        then SetPaletEntry(1,i,0,255,0)
        else SetPaletEntry(1,i,0,j,165-j)
      end;
     LoadPalette(1);
     Lagrange(p,number,x,y);
     Polyline(@x,@y,MAXL,kleur,nonclosed);
     for i:=0 to number do Marker(p[i].x,p[i].y,plus,kleur)
end;

procedure newcolor;
begin
      kleur:=kleur+1; if kleur>13 then kleur:=1;
      if kleur=13 then ClearViewport
end;

procedure startcolor;
begin
  ClearViewport;
  SetPaletEntry(1,-1,0,0,0);
  LoadPalette(1);
  kleur:=lightmagenta
end;

begin {edit}
  display;
  repeat
      Prompt('Click your menu choice:');
      ok:=ReadButton(q);
      case q of
        1: begin append; newcolor; display end;
        2: begin move; newcolor; display end;
        3: begin delete; newcolor; display end;
        5: begin startcolor; StuurpDef(p,number); display end;
        6: begin startcolor; display end;
        8: begin done:=true end;
      end
until done;
end; {edit}

begin (* main *)
     hello('Program 13','Lagrange interpolation','uk');
     SetUpGraphics;
     SetPaletEntry(1,-1,0,0,0);
     SetViewport(0,0.05,1,0.7, white);
     SetWindow(0,0.05,1,0.7);
     ClearViewport; kleur:=lightmagenta; StuurpDef(p,number);
     teksten[1]:='Add|point';
     teksten[2]:='Move|point';
     teksten[3]:='Delete|point';
     teksten[4]:='';
     teksten[5]:='Start|over';
     teksten[6]:='Delete|old crvs';
     teksten[7]:='';
     teksten[8]:='STOP';
     DefineButtons(teksten);
     done:=false;
     edit(done);
     DoneGraphics;
end.
