PROGRAM opgave6;  {bewerkt tbv betadag praktikum / EHD jan 1994}
                  {en vervolgens voor NEMO / EHD december 2007}
USES Dos,Crt,GritN,GritMath,cmstuf;

CONST
  maxvertcnt = 20;
  maxpoints  = 500;
  abstep     = 5.0;
  rstep      = 2.0;
  sdfstep    = 0.5;
  d2r        = 1.745329252E-2;

TYPE screenpoint = ARRAY[1..2] OF real;
     vidsarray   = ARRAY[1..maxvertcnt] OF integer;
     face3Dptr   = ^face3D;
     face3D      = RECORD
                     vertcnt,attr: integer;
                     vertids: vidsarray;
                     next: face3Dptr;
                     flag: boolean;     {flag tbv moebius procedure}
                   END;
     points      = ARRAY[1..maxpoints] OF VEC4;
     realarray   = ARRAY[1..24] OF real;

VAR
  hsron, incon, solidon : boolean;
  menu1,menu2,menu3: ButtTxtArr;
  a,ro,rp,b,s,d,f : real;
  theButton : integer;
  facecnt : integer; {Aantal vlakken in SPT file}
  nrPoints : integer;
  idummy : integer;
  world : points;    {Punten in SPT file}
  pic : face3Dptr;
  opnieuw: boolean;
label 10;

PROCEDURE InitParameters;
  BEGIN
    a:=0; b:=0; ro:=1; rp:=5; s:=1; d:=5; f:=1000;
  END; {InitParameters}

PROCEDURE DeleteSPTdata;
  VAR
    p1,p2 : face3Dptr;
  BEGIN
    IF pic<>NIL THEN
      BEGIN
        p1:=pic;
        p2:=p1^.next;
        REPEAT
          dispose(p1);
          p1:=p2;
          IF p2<>pic THEN p2:=p1^.next;
        UNTIL p1=pic;
        pic:=NIL;
      END;
  END; {DeleteSPTdata}

procedure ObjectMenu(var filename: string);
var i,theButton: integer;
begin
    menu3[1]:='house';
    menu3[2]:='cube';
    menu3[3]:='8-face';
    menu3[4]:='20-face';
    menu3[5]:='12-face';
    menu3[6]:='houses';
    menu3[7]:='sphere';
    menu3[8]:='cylinder';
    DefineButtons(menu3);
    Prompt('choose one of the objects');
    i:=ReadButton(theButton);
      case theButton of
        1: filename:='huis';
        2: filename:='kubus';
        3: filename:='octaeder';
        4: filename:='icosa';
        5: filename:='dodekaed';
        6: filename:='hofje';
        7: filename:='bol';
        8: filename:='cylind1';
      end; {case}
    filename:='spts\'+filename+'.spt';
    Prompt('');
end;

procedure ReadSPT (var face: face3Dptr; var vertcnt: integer);
  VAR
    i,j,k: integer;
    v: real;
    oldface,root: face3Dptr;
    filename,objectname: string;
    infile: text;
  BEGIN
    ObjectMenu(filename);
    assign(infile,filename);
    reset(infile);
    readln(infile,objectname);
    readln(infile,facecnt);
    root:=nil;
    FOR i:=1 TO facecnt DO
      BEGIN
        new(face);
        IF root=nil THEN root:=face ELSE oldface^.next:=face;
        oldface:=face;
        WITH face^ DO
        BEGIN
          read(infile,attr);
          j:=1;
          WHILE NOT eoln(infile) DO
          BEGIN
            IF j>maxvertcnt
            THEN Error('Too many vertices...!');
            read(infile,vertids[j]);
            j:=j+1
          END;
          vertcnt:=j-1;
          readln(infile);
          flag:=false;
        END;
      END;
    oldface^.next:=root;
    face:=root;
    readln(infile,vertcnt);
    FOR i:=1 TO vertcnt DO
      BEGIN
        FOR j:=1 TO 3 DO read(infile,world[i,j]);
        world[i,4]:=1;
        readln(infile)
      END;
  END; {ReadSPT}

PROCEDURE CalcMatrix (var M : MAT44);
  VAR
    N : MAT44;
  BEGIN
    Roty3D(a,M);
    Rotx3D(b,N);
    MMprod4(N,M,M);
    Transl3D(0,0,-rp,N);
    MMprod4(N,M,M);
    RtoL(N);
    MMprod4(N,M,M);
    EyeToClip(s,d,f,N);
    MMprod4(N,M,M);
  END; {CalcMatrices}

FUNCTION Visible (VAR x,y,z : realarray): boolean;
  VAR
    v1,v2,v3,normal : VEC4;
  BEGIN
    v1[1]:=x[1]; v1[2]:=y[1]; v1[3]:=z[1]; v1[4]:=1;
    v2[1]:=x[2]; v2[2]:=y[2]; v2[3]:=z[2]; v2[4]:=1;
    v3[1]:=x[3]; v3[2]:=y[3]; v3[3]:=z[3]; v3[4]:=1;
    Plane(v1,v2,v3,normal);
    Visible:=(normal[3]<0);
  END; {Visible}

FUNCTION Max (x,y,z : real): real;
  VAR
    i : real;
  BEGIN
    i:=x;
    if y>x then i:=y;
    if z>i then i:=z;
    Max:=i;
  END; {Max}

PROCEDURE FitInWindow;
  VAR
    xmin,xmax,ymin,ymax,zmin,zmax : real;
    x,y,z,factor : real;
    i : integer;
  BEGIN
    xmin:=world[1,1]; xmax:=xmin;
    ymin:=world[1,2]; ymax:=ymin;
    zmin:=world[1,3]; zmax:=zmin;
    FOR i:=2 TO nrPoints DO
      BEGIN
        x:=world[i,1]; y:=world[i,2]; z:=world[i,3];
        IF x<xmin THEN xmin:=x ELSE IF x>xmax THEN xmax:=x;
        IF y<ymin THEN ymin:=y ELSE IF y>ymax THEN ymax:=y;
        IF z<zmin THEN zmin:=y ELSE IF z>zmax THEN zmax:=z;
      END;
    x:=(xmin+xmax)/2;
    y:=(ymin+ymax)/2;
    z:=(zmin+zmax)/2;
    factor:=2/Max(xmax-xmin,ymax-ymin,zmax-zmin);
    FOR i:=1 TO nrPoints DO
      BEGIN
        world[i,1]:=(world[i,1]-x)*factor;
        world[i,2]:=(world[i,2]-y)*factor;
        world[i,3]:=(world[i,3]-z)*factor;
      END;
  END; {FitInWindow}

PROCEDURE DisplayPicture;
  VAR
    i,j,col : integer;
    x,y,z : realarray;
    face : face3Dptr;
    M : MAT44;
    vec : VEC4;
  BEGIN
    IF pic<>NIL THEN
      BEGIN
        ClearViewport;
        face:=pic;  {kopieer rootpointer}
        CalcMatriX(M);
        REPEAT
          WITH face^ DO
            BEGIN
              FOR i:=1 TO vertcnt DO
                BEGIN
                  FOR j:=1 TO 3 DO vec[j]:=world[vertids[i],j]; {copy coord.}
                  vec[4]:=1;  {vul homogene deel}
                  MVprod4(M,vec,vec); {in vec staat nu de gerot. coord.}
                  x[i]:=vec[1]/vec[4]; {copy naar x/y arrays}
                  y[i]:=vec[2]/vec[4];
                  z[i]:=vec[3]/vec[4];
                END; {Nu zijn de coordinaten v/e vlak geroteerd}
              IF hsron
              THEN
                BEGIN
                  IF Visible(x,y,z) THEN
                    IF solidon
                    THEN
                      BEGIN
                        col:=attr MOD 16; IF col=0 THEN col:=5;
                        FillArea(@x,@y,vertcnt,col);
                      END
                    ELSE PolyLine(@x,@y,vertcnt,green,closed);
                END
              ELSE PolyLine(@x,@y,vertcnt,green,closed);
              face:=face^.next; {ga naar volgende vlak}
            END; {with}
        UNTIL face=pic;
      END;
  END; {DisplayPicture}

PROCEDURE SetMenu1 (p2,p3 : boolean);
  BEGIN
    menu1[1]:='kies obj';
    hsron:=p2; IF hsron THEN menu1[3]:='wire'  ELSE menu1[3]:='solid';
    menu1[4]:='move';
    menu1[5]:='';
    solidon:=p3;
    IF hsron
    THEN IF solidon THEN menu1[6]:='no|colour' ELSE menu1[6]:='colour'
    ELSE menu1[6]:='';
    menu1[7]:='';
    menu1[8]:='stop';
    DefineButtons(menu1);  {Zet buttons op scherm}
  END; {SetMenu1}

PROCEDURE SetMenu2 (p2 : boolean);
  BEGIN
    menu2[1]:='vertical|axis';
    menu2[2]:='horizon-|tal axis';
    menu2[3]:='zoom out';
    menu2[4]:='zoom in';
    incon:=p2;
    menu2[7]:='reverse|rotation';
    menu2[8]:='main menu';
    DefineButtons(menu2);  {Zet buttons op scherm}
  END; {SetMenu2}



PROCEDURE Initialize;
  BEGIN
    incon:=TRUE;
    hsron:=FALSE;
    solidon:=FALSE;
    SetViewPort(0.15, 0.07, 0.78, 0.7, 0);
    SetWindow(-2, -2, 2, 2);
    pic:=NIL;
    InitParameters;
    opnieuw:=false;
  END; {Initialize}

PROCEDURE Menu2Dispatch;
  VAR
    quit, disp : boolean;
  BEGIN
    SetMenu2(incon);
    quit:=FALSE;
    REPEAT
      disp:=TRUE;
      idummy:=ReadButton(theButton);
      CASE theButton OF
        1: IF incon THEN a:=a+abstep*d2r ELSE a:=a-abstep*d2r;
        2: IF incon THEN b:=b+abstep*d2r ELSE b:=b-abstep*d2r;
        3: rp:=rp+rstep;
        4: BEGIN
             rp:=rp-rstep;
             IF rp<3 THEN rp:=3; {3 is minimum bij perpectief}
           END;
        7: BEGIN disp:=FALSE; SetMenu2(NOT incon); END;
        8: quit:=TRUE;
      END; {case}
      IF disp THEN DisplayPicture;
    UNTIL quit;
  END; {Menu2Dispatch}

procedure KiesObject;
begin
   DeleteSPTdata;
   ReadSPT(pic, nrPoints);
   FitInWindow;
   DisplayPicture;
   SetMenu1(hsron,solidon);
end;

PROCEDURE Menu1Dispatch;
  VAR
    quit : boolean;
    theButton,idummy: integer;
  BEGIN
    quit:=FALSE;
    REPEAT
      idummy:=ReadButton(theButton);
      CASE theButton OF
        1: BEGIN
             opnieuw:=true;
             exit
           END;
        2: BEGIN SetMenu1(hsron, solidon); DisplayPicture; END;
        3: BEGIN SetMenu1(NOT hsron, solidon); DisplayPicture; END;
        4: BEGIN Menu2Dispatch; SetMenu1(hsron, solidon); END;
        6: BEGIN SetMenu1(hsron, NOT solidon); DisplayPicture; END;
        8: quit:=TRUE;
      END; {case}
    UNTIL quit;
  END; {Menu1Dispatch}

BEGIN
  hello('Program 5',
        '3D visualization',
        'uk');
  SetUpGraphics;
10:  Initialize;
  KiesObject;
  Menu1Dispatch;
  if opnieuw then goto 10;
  DoneGraphics;
END.
