{$M 65300,0,655360}
{$N+}
program greedy_triangulation;
{juni 1986 rev juni 1994 voor wetenschapsmarkt rev 2007 voor NEMO}

uses Dos,Crt,GritN,cmstuf;

const MAXPUNT=30;
      MAXLIJN=(MAXPUNT*(MAXPUNT-1))div 2;

type punt = record x,y: real end;
     puntarray = array[1..MAXPUNT] of punt;
var i,j,knop: integer;
    s: puntarray;
    ade: byte;
    kr: boolean;
    uu,vv: real;


procedure triangulate(s: puntarray; n: integer);
{greedy triangulation}
type line = record first,last: punt; len: real;
                                     first_id,last_id: integer end;
     linarray = array[1..MAXLIJN] of line;
     intarray = array[1..MAXLIJN] of integer;
var i,j,k,nover2: integer;
    l,tr: linarray;
    index: intarray;
label verder;

procedure length(var l: line);
begin
     with l do len:=sqrt(sqr(first.x-last.x)+sqr(first.y-last.y));
end;

procedure ordenen(l: linarray; n: integer; var index: intarray);
var i,temp,nwiss: integer;
begin
     for i:=1 to n do index[i]:=i;
     repeat nwiss:=0;
            for i:=2 to n do
                begin if l[index[i]].len < l[index[i-1]].len then
                         begin temp:=index[i];
                               index[i]:=index[i-1];
                               index[i-1]:=temp;
                               nwiss:=nwiss+1
                         end
                end
     until nwiss=0
end;

procedure draw(l: line; color: integer);
begin
     DrawLine(l.first.x,l.first.y,l.last.x,l.last.y,color)
end;

function intersect(k,l: line): boolean;
{onderzoekt of k en l elkaar snijden}
type triple = array[1..3] of real;
var a,b,a1,a2,b1,b2: triple;
    aba,bab: boolean;


function inprod(a,b: triple): real;
begin
        inprod:= a[1]*b[1] + a[2]*b[2] + a[3]*b[3]
end;

procedure dual(p,q: triple; var l: triple);
{p, q punten, l hun verbindingslijn}
begin
      l[1]:= p[2]-q[2];
      l[2]:=-p[1]+q[1];
      l[3]:= p[1]*q[2]-p[2]*q[1];
end;

begin {intersect}
        {test for common vertex}
        if      (k.first_id = l.first_id) or
                (k.first_id = l.last_id) or
                (k.last_id = l.first_id) or
                (k.last_id = l.last_id) then
                          begin intersect:=false; exit end;
        {test for intersection}
        a1[1]:=k.first.x; a1[2]:=k.first.y; a1[3]:=1;
        a2[1]:=k.last.x; a2[2]:=k.last.y; a2[3]:=1;
        b1[1]:=l.first.x; b1[2]:=l.first.y; b1[3]:=1;
        b2[1]:=l.last.x; b2[2]:=l.last.y; b2[3]:=1;
        dual(a1,a2,a); dual(b1,b2,b);
        aba:= ( inprod(b,a1) * inprod(b,a2) ) < 0;
        bab:= ( inprod(a,b1) * inprod(a,b2) ) < 0;
        intersect:=bab and aba
end; {intersect}


begin {triangulate}
      k:=0;
      for i:=1 to n do
                for j:= i+1 to n do
              begin
                        k:=k+1;
                    l[k].first:=s[i];
                    l[k].last:=s[j];
                        l[k].first_id:=i;
                        l[k].last_id:=j;
                    length(l[k])
              end;
      nover2:=k;
      ordenen(l,nover2,index);
{
      Prompt('Nu worden ALLE verbindingslijnen getekend...');
      for i:=1 to nover2 do draw(l[index[i]],blue);
      Wait(2,ade);
}
      Prompt('Push a mouse button for adding a line to the triangulation');
      Wait(-2,ade);
      tr[1]:=l[index[1]];
      draw(tr[1],lightgreen);
      k:=1;
      for i:=2 to nover2 do
        begin
          for j:=1 to k do
             begin
                kr:=intersect(l[index[i]],tr[j]);
                if kr then goto verder
             end;
verder:   if not kr then
             begin
               k:=k+1;
               tr[k]:=l[index[i]];
               Prompt('Push a mouse button for adding a line to the triangulation');
               Wait(-2,ade);
               draw(tr[k],lightgreen)
             end
          end
end;

begin {trian}
  hello('Program 9',
        'Triangulation of a point set',
        'uk');
  SetupGraphics;
  SetViewport(0.05,0.05, 0.95,0.70, white);
  SetWindow(0.05,0.05, 0.95,0.70);
  REPEAT
    ClearViewport;
    Prompt('Click some points (lees than 30); click right AFTER the last point');
    i:=0;
    repeat
     repeat
       Locator(uu,vv,knop);
       if knop<2 then
         begin
           Marker(uu,vv,plus,lightred);
           if (uu<>s[i].x) or (vv<>s[i].y) then
             begin
               i:=i+1;
               s[i].x:=uu;
               s[i].y:=vv;
               for j:=1 to i do
                 DrawLine(s[j].x,s[j].y,s[i].x,s[i].y,lightblue);
               for j:=1 to i do
                 Marker(s[j].x,s[j].y,plus,lightred)
             end
         end
     until (knop=2) or (i=MAXPUNT);
    until i>1;
    triangulate(s,i);
    sound(440); delay(400); nosound;
    Prompt('The triangulation is ready. Hit <space> for another try, <s> to stop');
    Wait(-1,ade);
  UNTIL ade=ord('s');
  DoneGraphics;
end.
